##
##  gentle.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2008 OpenPKG Foundation e.V. <http://openpkg.net/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         gentle
Summary:      Compiler Construction System
URL:          http://gentle.compilertools.net/
Vendor:       FIRST
Packager:     OpenPKG Foundation e.V.
Distribution: OpenPKG Community
Class:        PLUS
Group:        CompilerCompiler
License:      GPL
Version:      97
Release:      20080101

#   list of sources
Source0:      ftp://ftp.openpkg.org/sources/CPY/gentle/gentle-%{version}.tar.gz
Patch0:       gentle.patch

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20040130
PreReq:       OpenPKG, openpkg >= 20040130
AutoReq:      no
AutoReqProv:  no

%description
    Gentle is a modern toolkit for compiler writers and implementors
    of domain specific languages. Gentle covers the full spectrum
    of translation. It supports language recognition, definition of
    abstract syntax trees, construction of tree walkers based on pattern
    matching, smart traversal, simple unparsing for source-to-source
    translation, and optimal code selection for microprocessors. Gentle
    provides a uniform framework for all of these tasks.

%track
    prog gentle = {
        disabled
        comment   = "rse: vendor changed license and our original version will not change anymore"
        version   = %{version}
        url       = ftp://ftp.openpkg.org/sources/CPY/gentle/
        regex     = gentle-(__VER__)\.tar\.gz
    }

%prep
    %setup -q
    %patch -p0
    %{l_shtool} subst -e 's;CC=cc;CC="%{l_cc} %{l_cflags -O}";' gentle/build
    %{l_shtool} subst -e 's;CC=cc;CC="%{l_cc} %{l_cflags -O}";' lib/build
    %{l_shtool} subst -e 's;cc;%{l_cc} %{l_cflags -O};' reflex/build

%build
    ( cd gentle && ./build ) || exit $?
    ( cd lib    && ./build ) || exit $?
    ( cd reflex && ./build ) || exit $?
    ar cr libgentle.a gentle/grts.o lib/*.o

%install
    rm -rf $RPM_BUILD_ROOT
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/lib \
        $RPM_BUILD_ROOT%{l_prefix}/share/gentle/html
    %{l_shtool} install -c -s -m 755 \
        gentle/gentle $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_shtool} install -c -s -m 755 \
        reflex/reflex $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_shtool} install -c -m 755 \
        libgentle.a $RPM_BUILD_ROOT%{l_prefix}/lib/
    %{l_shtool} install -c -m 644 \
        BOOK.html BOOK.ps $RPM_BUILD_ROOT%{l_prefix}/share/gentle/
    %{l_shtool} install -c -m 644 \
        html/* $RPM_BUILD_ROOT%{l_prefix}/share/gentle/html/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%doc %{l_prefix}/share/gentle/BOOK.*' \
        '%doc %{l_prefix}/share/gentle/html/*'

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

